/*
    ************************************************
    folderHorizon sidenavgroups.js
    * Group projects by @ separator
    * Context in sidenav_common.tpl
    * Loaded with section.tpl, project.tpl
    ************************************************
*/

var showSingleItemGroups = true, // Group has single item : show as group or replace the separator
    context = document.getElementById('sidenavList'),
    list = context.getElementsByTagName('li'),
    titleClass = 'project-group-title',
    projectClass = 'project-group',
    separator = '@',
    replacer = '-',
    groups = [],
    checkSingles = {},
    singleItemGroups = [],
    separatorErrors = []; // Directory name has more than one separator !

// Load groups
for (var i = 0; i < list.length; i++) {
    if (list[i].textContent.includes(separator)) {
        var group = list[i].textContent.split(separator);
        if (group.length !== 2) {
            separatorErrors.push(list[i].textContent)
        } else {
            groups.push(group[0].trim());
        }
    }
}

// Start
if (groups.length > 0) {

    var selectedTitle = '';

    // Project page titles !
    if (document.title.includes(separator) && !separatorErrors.includes(document.title)) {
        var count = document.title.split(separator);
        if (count.length === 2) {
            document.title = document.title.replace(separator, replacer);
            var cT = document.getElementsByClassName('content-title');
            if (cT.length !== 0) {
                var pGT = cT[0].textContent.split(separator);
                selectedTitle = pGT[0].trim();
                cT[0].textContent = cT[0].textContent.replace(separator, replacer);
            }
        }
    }

    // You choose...
    if (!showSingleItemGroups) {
        groups.forEach(function (x) { checkSingles[x] = (checkSingles[x] || 0) + 1; });
        for (var n in checkSingles) {
            if (!checkSingles.hasOwnProperty(n)) continue;
            if (checkSingles[n] < 2) singleItemGroups.push(n);
        }
    }

    // Reset and create groups
    groups = [];

    for (var i = 0; i < list.length; i++) {
        var el = list[i],
            text = el.textContent;

        if (separatorErrors.includes(text)) continue;
        if (text.includes(separator)) {
            var group = text.split(separator),
                title = group[0].trim(),
                project = group[1].trim();

            if (singleItemGroups.includes(title)) {
                el.firstElementChild.textContent = el.firstElementChild.textContent.replace(separator, replacer); // <a> !
            } else if (!groups.includes(title)) {
                var groupTitle = document.createElement('li');
                groupTitle.className = titleClass;
                groupTitle.dataset.class = projectClass;
                if (title === selectedTitle) groupTitle.classList.add('selected');
                groupTitle.dataset.group = title;
                groupTitle.textContent = title;
                groupTitle.addEventListener('click', function () {
                    this.classList.toggle('open');
                    var projectGroup = context.getElementsByClassName(this.dataset.class);
                    for (var i = 0; i < projectGroup.length; i++) {
                        if (projectGroup[i].dataset.group === this.dataset.group) projectGroup[i].classList.toggle('hide');
                    }
                });
                context.insertBefore(groupTitle, el);
                groups.push(title);
            } else if (groups.includes(title)) {
                el.dataset.group = title;
                el.classList.add(projectClass);
                el.classList.add('hide');
                el.firstElementChild.textContent = project; // <a> !
            }
        }
    }
}
